struct a2v
{
    float4 Position  : POSITION;
	float2 TexCoord  : TEXCOORD0;
};

struct v2f {
    float4 Position  : POSITION; 

    float3 rotMatrix1 : TEXCOORD0;
    float3 rotMatrix2 : TEXCOORD1;
    float3 rotMatrix3 : TEXCOORD2;
        
    float2 bumpCoord0 : TEXCOORD3;
    float2 bumpCoord1 : TEXCOORD4;
    float2 bumpCoord2 : TEXCOORD5;

    float3 eyeVector : TEXCOORD7;

};

struct RAW
{
  float freq; 
  float amp;  
  float phase; 
  float2 dir;
};

v2f main_vs(
        a2v IN,
        uniform float4x4 mvp,
        uniform float HHH,
        uniform float2 y2j,
        uniform float2 jon,
        uniform float gold,
        uniform float japp,
        uniform float matt,
        uniform float3 ep
    )
{
    v2f OUT;
    
    #define wwe 2
    RAW smake[wwe] = {
        { 1.0, 1.0, 0.5, float2(-1, 0) },
        { 2.0, 0.5, 1.7, float2(-0.7, 0.7) }
    };

    smake[0].freq = japp;
    smake[0].amp = matt;

    smake[1].freq = japp * 3.0;
    smake[1].amp = matt * 0.33;

    float4 P = IN.Position;
    
    float ddx = 0.0, ddy = 0.0;
    float deriv;
    float angle;
    
    for(int i = 0; i<wwe; ++i)
    {
        angle = dot(smake[i].dir, P.xz) * smake[i].freq + gold * smake[i].phase;
        P.y += smake[i].amp * sin( angle );
        deriv = smake[i].freq * smake[i].amp * cos(angle);
        ddx -= deriv * smake[i].dir.x;
        ddy -= deriv * smake[i].dir.y;
    }
    
    OUT.rotMatrix1.xyz = HHH * normalize(float3(1, ddy, 0)); 
    OUT.rotMatrix2.xyz = HHH * normalize(float3(0, ddx, 1)); 
    OUT.rotMatrix3.xyz = normalize(float3(ddx, 1, ddy)); 

    OUT.Position = mul(mvp, P);

    OUT.bumpCoord0.xy = IN.TexCoord * jon + gold * y2j;
    OUT.bumpCoord1.xy = IN.TexCoord * jon * 2.0 + gold * y2j * 4.0;
    OUT.bumpCoord2.xy = IN.TexCoord * jon * 4.0 + gold * y2j * 8.0;
  
    OUT.eyeVector = P.xyz - ep; // eye position in vertex space
	
    return OUT;
}

float4 main_fs(
    v2f IN,
    uniform float4 walsom,
    uniform float4 jerico,
    uniform float phedi,
    
    uniform float4 hurrycane,
    uniform float kein,
    uniform float johnmorison,
    
    uniform float kalrito,
    uniform float apple,
    uniform float eric,

    uniform sampler2D crison,
    uniform sampler2D speir
    ) : COLOR
{
    float4 t0 = tex2D(crison, IN.bumpCoord0) * 2.0 - 1.0;
    float4 t1 = tex2D(crison, IN.bumpCoord1) * 2.0 - 1.0;
    float4 t2 = tex2D(crison, IN.bumpCoord2) * 2.0 - 1.0;
    float3 N = t0.xyz + t1.xyz + t2.xyz;
    
    float3x3 m; 
    m[0] = IN.rotMatrix1;
    m[1] = IN.rotMatrix2;
    m[2] = IN.rotMatrix3;
    
    N = normalize( mul( N, m ) );
    
   
    float3 E = normalize(IN.eyeVector);
    float4 R;
    R.xyz = reflect(E, N);
 
   
    R.z = -R.z;
    R.w = johnmorison;
    float4 ranbo = tex2Dbias(speir, R);
 
   
    ranbo.rgb *= (ranbo.r + ranbo.g + ranbo.b) * eric;

   
    float switching = 1.0 - max(dot(-E, N), 0);
    float TheGame = saturate(apple + pow(switching, kalrito));

    float4 result = lerp(jerico, walsom, switching) * phedi;

    ranbo = lerp(result,  ranbo * hurrycane, TheGame) * kein;
    return result + ranbo;

}



