// Menu_Particle.cpp : implementation file
//

#include "../../Source/MFC_Core/stdafx.h"
#include "../../Source/MFC_Core/MapTool_3D.h"
#include "Menu_Particle.h"


// CMenu_Particle dialog

IMPLEMENT_DYNAMIC(CMenu_Particle, CDialog)

CMenu_Particle::CMenu_Particle(CWnd* pParent /*=NULL*/)
	: CDialog(CMenu_Particle::IDD, pParent)
	, m_Fog_Exp2(0.005)
	, m_Fog_Start(0)
	, m_Fog_end(1000)
	, m_Fog_Color_R(180)
	, m_Fog_Color_G(180)
	, m_Fog_Color_B(180)
	, m_Fog_Color_A(180)
{
	g_Option._Fog._using = true;
	g_Option._Fog.color = 0x1c1c1c1c;
	g_Option._Fog.exp2 = 0.005f;
	g_Option._Fog.fog_start = 0.0f;
	g_Option._Fog.fog_end = 1000.0f;

	
}

CMenu_Particle::~CMenu_Particle()
{
}

void CMenu_Particle::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PAR_C_FOG, m_Fog_Use);
	DDX_Text(pDX, IDC_FOG_EXP2, m_Fog_Exp2);
	DDV_MinMaxFloat(pDX, m_Fog_Exp2, 0, 1);

	DDX_Text(pDX, IDC_FOG_START, m_Fog_Start);
	DDV_MinMaxFloat(pDX, m_Fog_Start, 0.0, 1024.0);
	DDX_Text(pDX, IDC_FOG_END, m_Fog_end);
	DDV_MinMaxFloat(pDX, m_Fog_end, 0.0, 8024);

	DDX_Text(pDX, IDC_PAR_FORCOLOR_R, m_Fog_Color_R);
	DDV_MinMaxInt(pDX, m_Fog_Color_R, 0, 255);
	DDX_Text(pDX, IDC_PAR_FORCOLOR_G, m_Fog_Color_G);
	DDV_MinMaxInt(pDX, m_Fog_Color_G, 0, 255);
	DDX_Text(pDX, IDC_PAR_FORCOLOR_B, m_Fog_Color_B);
	DDV_MinMaxInt(pDX, m_Fog_Color_B, 0, 255);
	DDX_Text(pDX, IDC_PAR_FORCOLOR_A, m_Fog_Color_A);
	DDV_MinMaxInt(pDX, m_Fog_Color_A, 0, 255);
}


BEGIN_MESSAGE_MAP(CMenu_Particle, CDialog)
	ON_BN_CLICKED(IDC_PAR_C_FOG, &CMenu_Particle::OnBnClickedParCFog)
END_MESSAGE_MAP()


// CMenu_Particle message handlers


BOOL CMenu_Particle::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  Add extra initialization here
	((CButton*)GetDlgItem(IDC_PAR_C_FOG))->SetCheck(true);
	g_Option._Fog._using = true;

	((CButton*)GetDlgItem(IDC_PAR_FOG1))->SetCheck(true);
	g_Option._Fog.style = Fog::Linear;

	SetControlItem(Particle::All, true);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CMenu_Particle::PreTranslateMessage(MSG* pMsg)
{
	// TODO: Add your specialized code here and/or call the base class
	if(pMsg->message == WM_KEYDOWN)
	{
		if(pMsg->wParam == VK_ESCAPE) return TRUE;
		if(pMsg->wParam == VK_RETURN) return TRUE;

		this->UpdateData();

		if(((CButton*)GetDlgItem(IDC_PAR_FOG1))->GetCheck())
			g_Option._Fog.style = Fog::Linear;

		if(((CButton*)GetDlgItem(IDC_PAR_FOG2))->GetCheck())
			g_Option._Fog.style = Fog::Exp2;

		if(((CButton*)GetDlgItem(IDC_PAR_FOG3))->GetCheck())
			g_Option._Fog.style = Fog::Layer;

		if(((CButton*)GetDlgItem(IDC_PAR_C_FOG))->GetCheck())
			g_Option._Fog._using = true;
		else
			g_Option._Fog._using = false;

		g_Option._Fog.color = MAKELONG(MAKEWORD(m_Fog_Color_B,m_Fog_Color_G),MAKEWORD(m_Fog_Color_R,m_Fog_Color_A));
		g_Option._Fog.exp2 = m_Fog_Exp2;
		g_Option._Fog.fog_start = m_Fog_Start;
		g_Option._Fog.fog_end = m_Fog_end;

	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CMenu_Particle::SetControlItem(Particle flag, bool Enable)
{
	if(flag == Particle::Fog || flag == Particle::All)
	{
		((CButton*)GetDlgItem(IDC_PAR_FOG1))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_PAR_FOG2))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_PAR_FOG3))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_FOG_EXP2))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_FOG_START))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_FOG_END))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_PAR_FORCOLOR_R))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_PAR_FORCOLOR_G))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_PAR_FORCOLOR_B))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_PAR_FORCOLOR_A))->EnableWindow(Enable);
	}
}

void CMenu_Particle::OnBnClickedParCFog()
{
	// TODO: Add your control notification handler code here
	if(((CButton*)GetDlgItem(IDC_PAR_C_FOG))->GetCheck())
	{
		g_Option._Fog._using = true;
		SetControlItem(Particle::Fog, true);
	}
	else
	{
		g_Option._Fog._using = false;
		SetControlItem(Particle::Fog, false);
	}

}
