// Menu_Player.cpp : implementation file
//

#include "../../Source/MFC_Core/stdafx.h"
#include "../../Source/MFC_Core/MapTool_3D.h"
#include "Menu_Player.h"


// CMenu_Player dialog

IMPLEMENT_DYNAMIC(CMenu_Player, CDialog)

CMenu_Player::CMenu_Player(CWnd* pParent /*=NULL*/)
	: CDialog(CMenu_Player::IDD, pParent)
{
	g_Option._Play.camera = Play::_Camera::FPS;
	g_Option._Play.fillmode = D3DFILLMODE::D3DFILL_SOLID;
	g_Option._Play.color = D3DTEXTUREOP::D3DTOP_ADDSIGNED2X;     
	g_Option._Play.mag = D3DTEXTUREFILTERTYPE::D3DTEXF_ANISOTROPIC; 
	g_Option._Play.pow = D3DTEXTUREFILTERTYPE::D3DTEXF_ANISOTROPIC; 
	g_Option._Play.mip = D3DTEXTUREFILTERTYPE::D3DTEXF_ANISOTROPIC; 
	g_Option._Play.aniso = Play::_Anisotropy::AnisoX32;			
	g_Option._Play.pass = Play::_SinglePass::Single;		
}

CMenu_Player::~CMenu_Player()
{
}

void CMenu_Player::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CMenu_Player, CDialog)
END_MESSAGE_MAP()


// CMenu_Player message handlers

BOOL CMenu_Player::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  Add extra initialization here

	((CButton*)GetDlgItem(IDC_CAMERA_SET1))->SetCheck(true);
	((CButton*)GetDlgItem(IDC_DRAW1))->SetCheck(true);
	((CButton*)GetDlgItem(IDC_FILETER4))->SetCheck(true);
	((CButton*)GetDlgItem(IDC_POWER4))->SetCheck(true);
	((CButton*)GetDlgItem(IDC_POWER_ANIOS6))->SetCheck(true);
	((CButton*)GetDlgItem(IDC_MIPFILETER3))->SetCheck(true);
	((CButton*)GetDlgItem(IDC_RANDERMODE1))->SetCheck(true);
	((CButton*)GetDlgItem(IDC_COLOR_BLENDING5))->SetCheck(true);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CMenu_Player::PreTranslateMessage(MSG* pMsg)
{
	// TODO: Add your specialized code here and/or call the base class
	if(pMsg->message == WM_KEYDOWN)
	{
		if(pMsg->wParam == VK_ESCAPE) return TRUE;
		if(pMsg->wParam == VK_RETURN) return TRUE;
	}
	if(pMsg->message == WM_LBUTTONDOWN)
	{
		g_App.SelectMenuItems();
	}

	this->UpdateData();

	if(((CButton*)GetDlgItem(IDC_CAMERA_SET1))->GetCheck())
		g_Option._Play.camera = Play::_Camera::FPS;

	if(((CButton*)GetDlgItem(IDC_CAMERA_SET2))->GetCheck())
		g_Option._Play.camera = Play::_Camera::CRAFT;

	if(((CButton*)GetDlgItem(IDC_CAMERA_SET3))->GetCheck())
		g_Option._Play.camera = Play::_Camera::MMORPG;


	if(((CButton*)GetDlgItem(IDC_DRAW1))->GetCheck())
		g_Option._Play.fillmode = D3DFILLMODE::D3DFILL_SOLID;

	if(((CButton*)GetDlgItem(IDC_DRAW2))->GetCheck())
		g_Option._Play.fillmode = D3DFILLMODE::D3DFILL_WIREFRAME;


	if(((CButton*)GetDlgItem(IDC_FILETER1))->GetCheck())
		g_Option._Play.mag = D3DTEXTUREFILTERTYPE::D3DTEXF_NONE;

	if(((CButton*)GetDlgItem(IDC_FILETER2))->GetCheck())
		g_Option._Play.mag = D3DTEXTUREFILTERTYPE::D3DTEXF_POINT;

	if(((CButton*)GetDlgItem(IDC_FILETER3))->GetCheck())
		g_Option._Play.mag = D3DTEXTUREFILTERTYPE::D3DTEXF_LINEAR;

	if(((CButton*)GetDlgItem(IDC_FILETER4))->GetCheck())
		g_Option._Play.mag = D3DTEXTUREFILTERTYPE::D3DTEXF_ANISOTROPIC;


	if(((CButton*)GetDlgItem(IDC_POWER1))->GetCheck())
		g_Option._Play.pow = D3DTEXTUREFILTERTYPE::D3DTEXF_NONE;

	if(((CButton*)GetDlgItem(IDC_POWER2))->GetCheck())
		g_Option._Play.pow = D3DTEXTUREFILTERTYPE::D3DTEXF_POINT;

	if(((CButton*)GetDlgItem(IDC_POWER3))->GetCheck())
		g_Option._Play.pow = D3DTEXTUREFILTERTYPE::D3DTEXF_LINEAR;

	if(((CButton*)GetDlgItem(IDC_POWER4))->GetCheck())
		g_Option._Play.pow = D3DTEXTUREFILTERTYPE::D3DTEXF_ANISOTROPIC;


	if(((CButton*)GetDlgItem(IDC_POWER_ANIOS1))->GetCheck())
		g_Option._Play.aniso = Play::_Anisotropy::AnisoX1;

	if(((CButton*)GetDlgItem(IDC_POWER_ANIOS2))->GetCheck())
		g_Option._Play.aniso = Play::_Anisotropy::AnisoX2;

	if(((CButton*)GetDlgItem(IDC_POWER_ANIOS3))->GetCheck())
		g_Option._Play.aniso = Play::_Anisotropy::AnisoX4;

	if(((CButton*)GetDlgItem(IDC_POWER_ANIOS4))->GetCheck())
		g_Option._Play.aniso = Play::_Anisotropy::AnisoX8;

	if(((CButton*)GetDlgItem(IDC_POWER_ANIOS5))->GetCheck())
		g_Option._Play.aniso = Play::_Anisotropy::AnisoX16;

	if(((CButton*)GetDlgItem(IDC_POWER_ANIOS6))->GetCheck())
		g_Option._Play.aniso = Play::_Anisotropy::AnisoX32;

	if(((CButton*)GetDlgItem(IDC_POWER_ANIOS7))->GetCheck())
		g_Option._Play.aniso = Play::_Anisotropy::AnisoX64;


	if(((CButton*)GetDlgItem(IDC_MIPFILETER1))->GetCheck())
		g_Option._Play.mip = D3DTEXTUREFILTERTYPE::D3DTEXF_NONE;

	if(((CButton*)GetDlgItem(IDC_MIPFILETER2))->GetCheck())
		g_Option._Play.mip = D3DTEXTUREFILTERTYPE::D3DTEXF_POINT;

	if(((CButton*)GetDlgItem(IDC_MIPFILETER3))->GetCheck())
		g_Option._Play.mip = D3DTEXTUREFILTERTYPE::D3DTEXF_LINEAR;


	if(((CButton*)GetDlgItem(IDC_RANDERMODE1))->GetCheck())
		g_Option._Play.pass = Play::_SinglePass::Single;

	if(((CButton*)GetDlgItem(IDC_RANDERMODE2))->GetCheck())
		g_Option._Play.pass = Play::_SinglePass::Multi;


	if(((CButton*)GetDlgItem(IDC_COLOR_BLENDING1))->GetCheck())
		g_Option._Play.color = D3DTEXTUREOP::D3DTOP_ADDSIGNED;

	if(((CButton*)GetDlgItem(IDC_COLOR_BLENDING2))->GetCheck())
		g_Option._Play.color = D3DTEXTUREOP::D3DTOP_MODULATE2X;

	if(((CButton*)GetDlgItem(IDC_COLOR_BLENDING3))->GetCheck())
		g_Option._Play.color = D3DTEXTUREOP::D3DTOP_MODULATE;

	if(((CButton*)GetDlgItem(IDC_COLOR_BLENDING4))->GetCheck())
		g_Option._Play.color = D3DTEXTUREOP::D3DTOP_ADD;

	if(((CButton*)GetDlgItem(IDC_COLOR_BLENDING5))->GetCheck())
		g_Option._Play.color = D3DTEXTUREOP::D3DTOP_ADDSIGNED2X;

	if(((CButton*)GetDlgItem(IDC_COLOR_BLENDING6))->GetCheck())
		g_Option._Play.color = D3DTEXTUREOP::D3DTOP_MODULATE4X;

	if(((CButton*)GetDlgItem(IDC_COLOR_BLENDING7))->GetCheck())
		g_Option._Play.color = D3DTEXTUREOP::D3DTOP_SUBTRACT;

	return CDialog::PreTranslateMessage(pMsg);
}
