#include "../../Source/MFC_Core/stdafx.h"
#include "Shader_Fog.h"

Shader_Fog::Shader_Fog()
{
	FogEffect   = NULL;
	FogTechHandle = NULL;
}

Shader_Fog::~Shader_Fog()
{

	FogEffect->Release();
	FogTechHandle = NULL;

}

bool Shader_Fog::Init(LPDIRECT3DDEVICE9 pDevice)
{
	HRESULT hr = 0;
	//
	// Create effect.
	//
	ID3DXBuffer* errorBuffer = 0;
	hr = D3DXCreateEffectFromFile(
		pDevice,
		L"Effect/Shader/Fog.fx",
		0,                // no preprocessor definitions
		0,                // no ID3DXInclude interface
		D3DXSHADER_DEBUG, // compile flags
		0,                // don't share parameters
		&FogEffect,
		&errorBuffer);

	// output any error messages
	if( errorBuffer )
	{
		::MessageBox(0, (wchar_t*)errorBuffer->GetBufferPointer(), 0, 0);
		errorBuffer->Release();

		return false;
	}

	// 
	// Save Frequently Accessed Parameter Handles
	//

	FogTechHandle = FogEffect->GetTechniqueByName("Fog");

	return true;
}

void Shader_Fog::Rander_Begin_Exp2(float exp2, int Color)
{
	FogEffect->SetTechnique( FogTechHandle );

	FogEffect->SetFloat("exp2", exp2);
	FogEffect->SetInt("color", Color);

	UINT numPasses = 0;
	FogEffect->Begin(&numPasses, 0);

	FogEffect->BeginPass(0);
}

void Shader_Fog::Rander_Begin_LINEAR(float start, float end, int Color)
{
	FogEffect->SetTechnique( FogTechHandle );

	FogEffect->SetFloat("start", start);
	FogEffect->SetFloat("end", end);
	FogEffect->SetInt("color", Color);

	UINT numPasses = 0;
	FogEffect->Begin(&numPasses, 0);

	FogEffect->BeginPass(1);
}

void Shader_Fog::Rander_End()
{
	FogEffect->End();
}
