#ifndef _SHADER_WATER_H_
#define _SHADER_WATER_H_

#include <Windows.h>
#include <mmsystem.h>
#include <d3dx9.h>
#include <stdio.h>
#include <math.h>

#include "camera.h"
#include "surface.h"

#include "parameterhandler.h"
#include "software_noisemaker.h"

#define PI	3.1415926535898

enum rs_mode
{
	rsm_normal=0,
	rsm_refraction,
	rsm_reflection,
	rsm_reflection_backface,
};

struct camera_info
{
	D3DXVECTOR3 pos;
	float rotx;
	float roty;
	float rotz;
	float fov;
	float aspect;
	float nearz;
	float farz;
};

class Shader_Water
{
public:
	Shader_Water();
	~Shader_Water();
	void Init(LPDIRECT3DDEVICE9 pDevice, D3DXVECTOR3 position, float Width, float Height,
				const LPWSTR WaterTextureName, const LPWSTR SkyTextureName, camera_info camera_information);
	void loadpreset(int n);
	void Rander(D3DXVECTOR3 eyePosition);

	surface			 *GetSurface()	{ return sea; }
	parameterhandler *GetParameta() { return prm; }
	
private:
	void SetParameta();
	void SetupMatrices();
	void render_refracted_scene();			//  Ű
	void render_reflected_scene();			// ݻŰ
	
	float getheight(float x, float z);
	void set_clipplane_height(float height);
	void render_scene(int mode);
	void render_actual_scene();				//   ǥ
	
	LPDIRECT3DDEVICE9       g_pd3dDevice;
	LPDIRECT3DSURFACE9		g_depthstencil;
	LPDIRECT3DTEXTURE9		terrain_texture;
	LPD3DXEFFECT			terrain_effect;

	surface					*sea;
	parameterhandler		*prm;
	camera					*camera_mouse;

};

#endif